/* $Id: cpl_wlcalib_xc.h,v 1.2 2008/07/21 08:48:40 llundin Exp $
 *
 * This file is part of the ESO Common Pipeline Library
 * Copyright (C) 2001-2008 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: llundin $
 * $Date: 2008/07/21 08:48:40 $
 * $Revision: 1.2 $
 * $Name: cpl-4_2_0b3 $
 */

#ifndef CPL_WLCALIB_XC_H
#define CPL_WLCALIB_XC_H

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#include <cpl_polynomial.h>
#include <cpl_vector.h>
#include <cpl_bivector.h>
#include <cpl_table.h>

CPL_BEGIN_DECLS

/*-----------------------------------------------------------------------------
                                    Define
 -----------------------------------------------------------------------------*/

/* The 4 columns of the table */
#define CPL_WLCALIB_XC_COL_WAVELENGTH   "Wavelength"
#define CPL_WLCALIB_XC_COL_CAT_INIT     "Catalog Initial"
#define CPL_WLCALIB_XC_COL_CAT_FINAL    "Catalog Corrected"
#define CPL_WLCALIB_XC_COL_OBS          "Observed"

/*-----------------------------------------------------------------------------
                                Functions prototypes
 -----------------------------------------------------------------------------*/

cpl_polynomial * cpl_wlcalib_xc_best_poly(const cpl_vector *, 
        const cpl_bivector *, int, const cpl_polynomial *, const cpl_vector *, 
        int, double, double, double *, cpl_table **, cpl_vector **) ;
cpl_table * cpl_wlcalib_xc_gen_spc_table(const cpl_vector *, 
        const cpl_bivector *, double, double, const cpl_polynomial *,
        const cpl_polynomial *) ;
cpl_bivector * cpl_wlcalib_xc_cat_extract(const cpl_bivector *, double, double);
cpl_vector * cpl_wlcalib_xc_convolve_create_kernel(double, double) ;
int cpl_wlcalib_xc_convolve(cpl_vector *,const cpl_vector *) ;

CPL_END_DECLS

#endif
